
#include "WidgetDriver.h"
#include "WidgetDriverImpl.h"
#include <cassert>

namespace ghost{

	namespace widget{

		Driver_::Driver_(HWND hWnd)
			: pImpl_(new DriverImpl_(hWnd))
		{
		}

		Driver_::~Driver_()
		{
			delete pImpl_;
		}

		void Driver_::SetRootWidget(Widget* pRootWidget)
		{
			pImpl_->SetRootWidget(pRootWidget);
		}

		HWND Driver_::GetContainerWindow() const
		{
			return pImpl_->GetContainerWindow();
		}

		Widget* Driver_::GetRootWidget() const
		{
			return pImpl_->GetRootWidget();
		}

	} // namespace widget

} // namespace ghost