
#include "WidgetDriverImpl.h"
#include "WidgetMessageFilter.h"
#include "Widget.h"
#include <Windows.h>
#include <cassert>

namespace ghost{

	namespace widget{

		DriverImpl_::DriverImpl_(HWND hWnd)
			: hContainerWnd_(hWnd)
			, originalProc_(0)
			, pRootWidget_(0)
		{
#ifdef _DEBUG
			assert(::IsWindow(hContainerWnd_));
			// ܶͬһ
			assert(GetContainerWindows().insert(hContainerWnd_).second);
#endif // _DEBUG
			assert(thunk_.Init(StartWndProc, this));
			originalProc_ = (WNDPROC)::SetWindowLong(hContainerWnd_, GWL_WNDPROC, (LONG)thunk_.GetPROC());
		}
		DriverImpl_::~DriverImpl_()
		{
#ifdef _DEBUG
			GetContainerWindows().erase(hContainerWnd_);
#endif // _DEBUG
			if (::IsWindow(hContainerWnd_))
			{
				::SetWindowLong(hContainerWnd_, GWL_WNDPROC, (LONG)originalProc_);
			}
		}

		void DriverImpl_::SetRootWidget(Widget* pRootWidget)
		{
			pRootWidget_ = pRootWidget;
		}

		LRESULT DriverImpl_::WndProc(UINT message, WPARAM wParam, LPARAM lParam)
		{
			// Ϣ
			MessageFilter::Param param;
			param.hWnd = hContainerWnd_;
			param.originalProc = originalProc_;
			param.message = message;
			param.wParam = wParam;
			param.lParam = lParam;
			return MessageFilter::Filter(param, GetRootWidget());
		}

		LRESULT CALLBACK DriverImpl_::StartWndProc(
			HWND hWnd, 
			UINT message, 
			WPARAM wParam, 
			LPARAM lParam)
		{
			DriverImpl_* pThis = (DriverImpl_*)hWnd;
			return pThis->WndProc(message, wParam, lParam);
		}

#ifdef _DEBUG
		std::set<HWND>& DriverImpl_::GetContainerWindows()
		{
			static std::set<HWND> wnds;
			return wnds;
		}
#endif // _DEBUG

	} // namespace widget

} // namespace ghost