
#ifndef WIDGET_DRIVER_IMPL_H
#define WIDGET_DRIVER_IMPL_H

#include "../Thunk/ProcThunk.h"
#ifdef _DEBUG
#include <set>
#endif // _DEBUG

namespace ghost{

	class Widget;

	namespace widget{

		class Driver_;

		class DriverImpl_{
			friend class Driver_;

			window::ProcThunk thunk_;
			HWND hContainerWnd_;
			WNDPROC originalProc_;

			Widget* pRootWidget_;

		private:
			explicit DriverImpl_(HWND hWnd);
			~DriverImpl_();

		private:
			DriverImpl_(const DriverImpl_&);
			DriverImpl_& operator =(const DriverImpl_&);

		private:
			void SetRootWidget(Widget* pRootWidget);
			HWND GetContainerWindow() const{return hContainerWnd_;}
			Widget* GetRootWidget() const{return pRootWidget_;}

		private:
			LRESULT WndProc(UINT message, WPARAM wParam, LPARAM lParam);
			// ڳʼthunkĴڹ
			static LRESULT CALLBACK StartWndProc(
				HWND hWnd, 
				UINT message, 
				WPARAM wParam, 
				LPARAM lParam);
#ifdef _DEBUG
			static std::set<HWND>& GetContainerWindows();
#endif // _DEBUG
		};

	} // namespace widget

} // namespace ghost

#endif // WIDGET_DRIVER_IMPL_H