
#include "WidgetMessageFilter.h"
#include "Widget.h"
#include <cassert>
#include <Windows.h>

#ifdef _DEBUG
#include <sstream>
#include <iomanip>
#endif // _DEBUG

namespace ghost{

	namespace widget{

		LRESULT MessageFilter::Filter(const Param& param, Widget* pRootWidget)
		{
			assert(param.originalProc);
			assert(pRootWidget);
#ifdef _DEBUG
			std::stringstream ss;
			ss<<"Ϣ: "<<std::showbase<<std::hex<<param.message<<" WidgetϢˣ\r\n";
			::OutputDebugStringA(ss.str().c_str());
#endif // _DEBUG

			LRESULT ret = ::CallWindowProc(
				param.originalProc, 
				param.hWnd, 
				param.message, 
				param.wParam, 
				param.lParam);

			if (WM_DESTROY == param.message)
			{
				// ٸؼ
				pRootWidget->Destroy();
			}

			return ret;
		}

	} // namespace widget

} // namespace ghost